UIPackage
Menu

Framework

Change language

Boilerplate repo

Effect Scatter Chart

effect-scatter-chartui

Effect scatter chart with ripple animation around Apache ECharts. Highlights live points and alerts with a configurable ripple period. Theme-aware via registry tokens.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/effect-scatter-chart.json
Named registry:npx shadcn-vue@latest add @uipkge/effect-scatter-chartInstalls to:app/components/ui/charts/effect-scatter-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
dataRecord<string, any>[]required
xFieldstring'x'optional
yFieldstring'y'optional
categoryFieldstringoptional
ripplePeriod

Ripple animation period in seconds. Default 4.

number4optional
heightnumber | string300optional
optionanyoptional
classstringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

npm dependencies

Used by

Files installed (3)

  • app/components/ui/charts/effect-scatter-chart/EffectScatterChart.vue3.9 kB
    <script setup lang="ts">
    import { computed } from 'vue'
    import { use } from 'echarts/core'
    import { CanvasRenderer } from 'echarts/renderers'
    import { EffectScatterChart as EChartsEffectScatter } from 'echarts/charts'
    import { GridComponent, TooltipComponent, LegendComponent } from 'echarts/components'
    import VChart from 'vue-echarts'
    import { cn } from '@/lib/utils'
    import {
      chartColors,
      chartTextColor,
      chartAxisColor,
      chartSplitLineColor,
      chartTooltipBg,
      chartTooltipBorder,
      chartTooltipText,
      mergeOptionBlock,
    } from '../useChartTheme'
    
    use([CanvasRenderer, EChartsEffectScatter, GridComponent, TooltipComponent, LegendComponent])
    
    interface Props {
      data: Record<string, any>[]
      xField?: string
      yField?: string
      categoryField?: string
      /** Ripple animation period in seconds. Default 4. */
      ripplePeriod?: number
      height?: number | string
      option?: any
      class?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    const props = withDefaults(defineProps<Props>(), {
      xField: 'x',
      yField: 'y',
      ripplePeriod: 4,
      height: 300,
    })
    
    const mergedOption = computed(() => {
      const categories = props.categoryField ? [...new Set(props.data.map((d) => d[props.categoryField!]))] : ['default']
      const series = categories.map((cat, i) => ({
        name: String(cat),
        type: 'effectScatter',
        showEffectOn: 'render',
        rippleEffect: { brushType: 'stroke', period: props.ripplePeriod, scale: 3 },
        symbolSize: 12,
        itemStyle: {
          color: chartColors.value[i % chartColors.value.length],
          shadowBlur: 8,
          shadowColor: chartColors.value[i % chartColors.value.length],
        },
        data: (props.categoryField ? props.data.filter((d) => d[props.categoryField!] === cat) : props.data).map((d) => [
          d[props.xField!],
          d[props.yField!],
        ]),
      }))
    
      const userOption: any = props.option ?? {}
      const {
        series: userSeries,
        xAxis: userXAxis,
        yAxis: userYAxis,
        grid: userGrid,
        tooltip: userTooltip,
        legend: userLegend,
        ...userRest
      } = userOption
      const mergedSeries = Array.isArray(userSeries) ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) })) : series
    
      return {
        color: chartColors.value,
        grid: mergeOptionBlock(
          { left: 16, right: 16, top: 24, bottom: categories.length > 1 ? 32 : 24, containLabel: true },
          userGrid,
        ),
        tooltip: mergeOptionBlock(
          {
            trigger: 'item',
            backgroundColor: chartTooltipBg.value,
            borderColor: chartTooltipBorder.value,
            textStyle: { color: chartTooltipText.value, fontSize: 12 },
          },
          userTooltip,
        ),
        legend:
          categories.length > 1
            ? mergeOptionBlock(
                {
                  bottom: 0,
                  icon: 'circle',
                  itemWidth: 8,
                  itemHeight: 8,
                  textStyle: { fontSize: 11, color: chartTextColor.value },
                },
                userLegend,
              )
            : undefined,
        xAxis: mergeOptionBlock(
          {
            type: 'value',
            scale: true,
            splitLine: { lineStyle: { color: chartSplitLineColor.value } },
            axisLabel: { color: chartTextColor.value, fontSize: 11 },
            axisLine: { lineStyle: { color: chartAxisColor.value } },
          },
          userXAxis,
        ),
        yAxis: mergeOptionBlock(
          {
            type: 'value',
            scale: true,
            splitLine: { lineStyle: { color: chartSplitLineColor.value } },
            axisLabel: { color: chartTextColor.value, fontSize: 11 },
          },
          userYAxis,
        ),
        series: mergedSeries,
        ...userRest,
      }
    })
    </script>
    
    <template>
      <div
        role="img"
        tabindex="0"
        :aria-label="ariaLabel || 'Chart'"
        :style="{ height: /^\d+$/.test(String(height)) ? `${height}px` : String(height) }"
        :class="cn('focus-visible:ring-ring w-full focus-visible:ring-2 focus-visible:outline-none', props.class)"
      >
        <VChart :option="mergedOption" :autoresize="true" class="size-full" />
      </div>
    </template>
    
  • app/components/ui/charts/effect-scatter-chart/index.ts0.1 kB
  • app/components/ui/charts/useChartTheme.ts8.2 kB

Raw manifest:https://uipkge.dev/r/vue/effect-scatter-chart.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Effect Scatter Chart

effect-scatter-chartui

React mirror of @uipkge/effect-scatter-chart — see the Vue registry item for the canonical description.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/effect-scatter-chart.json
Named registry:npx shadcn@latest add @uipkge-react/effect-scatter-chartInstalls to:components/ui/charts/effect-scatter-chart/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
dataRecord<string, any>[]required
xFieldstringoptional
yFieldstringoptional
categoryFieldstringoptional
ripplePeriod

Ripple animation period in seconds. Default 4.

numberoptional
heightnumber | stringoptional
optionanyoptional
classNamestringoptional
ariaLabel

Accessible name announced for the chart image. Defaults to "Chart".

stringoptional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

ChartTheme
interface ChartTheme {
  colors: string[]
  textColor: string
  axisColor: string
  splitLineColor: string
  tooltipBg: string
  tooltipBorder: string
  tooltipText: string
  bgColor: string
  /** The app's accent, for the one highlighted element on a chart or map —
   *  a selected route, a focused bar. Category series keep using `colors`. */
  accentColor: string
  /** Out-of-bounds / failure colour for charts that encode good vs bad
   *  rather than a category — control limits, error series. CSS-level marks
   *  can use `var(--destructive)` directly; this exists because ECharts needs
   *  a resolved colour string on the canvas. */
  dangerColor: string
}

npm dependencies

Used by

Files installed (4)

  • components/ui/charts/effect-scatter-chart/EffectScatterChart.tsx3.8 kB
    'use client'
    
    import * as React from 'react'
    import { ChartFrame, EChart } from '../shared'
    import { useChartTheme, mergeOptionBlock } from '../useChartTheme'
    
    // EffectScatterChart
    // ─────────────────────────────────────────────────────────────────────────
    
    export interface EffectScatterChartProps {
      data: Record<string, any>[]
      xField?: string
      yField?: string
      categoryField?: string
      /** Ripple animation period in seconds. Default 4. */
      ripplePeriod?: number
      height?: number | string
      option?: any
      className?: string
      /** Accessible name announced for the chart image. Defaults to "Chart". */
      ariaLabel?: string
    }
    
    export const EffectScatterChart = React.forwardRef<HTMLDivElement, EffectScatterChartProps>(
      (
        { data, xField = 'x', yField = 'y', categoryField, ripplePeriod = 4, height = 300, option, className, ariaLabel },
        ref,
      ) => {
        const theme = useChartTheme()
    
        const mergedOption = React.useMemo(() => {
          const categories = categoryField ? [...new Set(data.map((d) => d[categoryField]))] : ['default']
          const series = categories.map((cat, i) => ({
            name: String(cat),
            type: 'effectScatter',
            showEffectOn: 'render',
            rippleEffect: { brushType: 'stroke', period: ripplePeriod, scale: 3 },
            symbolSize: 12,
            itemStyle: {
              color: theme.colors[i % theme.colors.length],
              shadowBlur: 8,
              shadowColor: theme.colors[i % theme.colors.length],
            },
            data: (categoryField ? data.filter((d) => d[categoryField] === cat) : data).map((d) => [d[xField], d[yField]]),
          }))
          const userOption: any = option ?? {}
          const {
            series: userSeries,
            xAxis: userXAxis,
            yAxis: userYAxis,
            grid: userGrid,
            tooltip: userTooltip,
            legend: userLegend,
            ...userRest
          } = userOption
          const mergedSeries = Array.isArray(userSeries)
            ? series.map((s, i) => ({ ...s, ...(userSeries[i] ?? {}) }))
            : series
    
          return {
            color: theme.colors,
            grid: mergeOptionBlock(
              { left: 16, right: 16, top: 24, bottom: categories.length > 1 ? 32 : 24, containLabel: true },
              userGrid,
            ),
            tooltip: mergeOptionBlock(
              {
                trigger: 'item',
                backgroundColor: theme.tooltipBg,
                borderColor: theme.tooltipBorder,
                textStyle: { color: theme.tooltipText, fontSize: 12 },
              },
              userTooltip,
            ),
            legend:
              categories.length > 1
                ? mergeOptionBlock(
                    {
                      bottom: 0,
                      icon: 'circle',
                      itemWidth: 8,
                      itemHeight: 8,
                      textStyle: { fontSize: 11, color: theme.textColor },
                    },
                    userLegend,
                  )
                : undefined,
            xAxis: mergeOptionBlock(
              {
                type: 'value',
                scale: true,
                splitLine: { lineStyle: { color: theme.splitLineColor } },
                axisLabel: { color: theme.textColor, fontSize: 11 },
                axisLine: { lineStyle: { color: theme.axisColor } },
              },
              userXAxis,
            ),
            yAxis: mergeOptionBlock(
              {
                type: 'value',
                scale: true,
                splitLine: { lineStyle: { color: theme.splitLineColor } },
                axisLabel: { color: theme.textColor, fontSize: 11 },
              },
              userYAxis,
            ),
            series: mergedSeries,
            ...userRest,
          }
        }, [data, xField, yField, categoryField, ripplePeriod, option, theme])
    
        return (
          <ChartFrame ref={ref} height={height} className={className} ariaLabel={ariaLabel}>
            <EChart option={mergedOption} />
          </ChartFrame>
        )
      },
    )
    EffectScatterChart.displayName = 'EffectScatterChart'
    
  • components/ui/charts/effect-scatter-chart/index.ts0.1 kB
  • components/ui/charts/useChartTheme.ts8.7 kB
  • components/ui/charts/shared.tsx3.7 kB

Raw manifest:https://uipkge.dev/r/react/effect-scatter-chart.json